#pragma once
class vm1g_plm
{
	// 
	bool p[250];	//wire [249:2]
	bool pl[34];	//wire [33:0]

#ifdef _WIN64
	QWORD m_plm[34][4];
#else
	DWORD m_plm[34][8];
#endif
	DWORD m_nPrevAi;
	/*
	 cmp       
	*/
	static const DWORD ignore_bits[250];
	static const DWORD mask_bits[250];

	inline bool cmp(DWORD ai, DWORD mi, DWORD ig)
	{
		/*
		casex(ai)
		mi:      cmp = 1'b1;
		default: cmp = 1'b0;
		endcase
		 ai      x   mi
		  1,  0
		*/
		return ((ai & ig) == mi);
	}
public:
	vm1g_plm();
	~vm1g_plm();
	void eval(DWORD ir, DWORD mr, bool *sp);

};

