//
//  MPI_HD.cpp
//

#include "MPI_BIN.h"

// #define L(x) pHooks->DisAsmStrOut(x,false)
#define L(x) { FILE *MPI_log=fopen( "MPI.log", "a"); fprintf(MPI_log, x ); fclose( MPI_log ); }

//
//
//

MPI_BIN::MPI_BIN( const char *acBIN_File, const byte *pMemory )
{
	byte *aMemory = (byte*)pMemory;

    int hBIN = open( acBIN_File, O_RDONLY | O_BINARY );

    if( hBIN <= 0 )
    {
      printf("BIN file not found--[%s]\n", acBIN_File );
      return;
    }

	read( hBIN, aMemory, 0x10000 );
   
	printf("%s read to RAM \n", acBIN_File );
	
	close( hBIN );
}
