//
//  MPI_DL11.h -    .
//
#ifndef MPI_DL11_Defs
#define MPI_DL11_Defs

#include "MPI_model.h"


/////////////////

static const word  TTKS = 0177560;
static const word  TTKB = TTKS+2;
static const word  TTPS = TTKS+4;
static const word  TTPB = TTKS+6;

static const word  TTKINT = 060;
static const word  TTPINT = 064;

class MPI_DL11 : public MPI_DeviceClass {
public:
	virtual ~MPI_DL11(){}
	MPI_DL11();

protected:
	virtual void  IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData );
	virtual void  Init();
	virtual void  Clock();
	
	word  wTTKS;
	word  wTTKB;
	word  wTTPS;
	word  wTTPB;

	word  nTTK_Ready_res;
	bool  bLast_TTP_IntEnable;
	bool  bLast_TTK_IntEnable;
	
	byte  cRusLat;
};


#endif
