//
//    EVNT   .
//

#include "MPI_LTC.h"


// #define L(x) pHooks->DisAsmStrOut(x,false)
#define L(x) { FILE *MPI_log=fopen( "MPI.log", "a"); fprintf(MPI_log, x ); fclose( MPI_log ); }

//
//
void MPI_LTC::Clock()
{
	if( pVM1_bus->CLC )
	{
		return;
	}

	if( !( pVM1_bus->qwClocksCount % 10000 ) )
	{
		dword uTC;

		if( qw1ms )
		{
			LARGE_INTEGER Cnt;
			QueryPerformanceCounter( &Cnt );
			uTC = Cnt.QuadPart/qw1ms;
		}
		else
		{
			uTC = GetTickCount();
		}
		
		if( !nFlips )
		{
			uStartTC = uTC;
			nFlips   = 1;
		}
/*
{
char str[512];
sprintf(str,"uTC: %u  ;  uStartTC: %u  ;  (uTC - uStartTC)/10 : %u \n", uTC, uStartTC, (uTC - uStartTC)/10 );
L(str);
}//*/
		if( uTC < uStartTC ) { uStartTC = 0; nFlips = 1; }

		if( (uTC - uStartTC)/10 > nFlips )
		{
			nFlips++;
			
			pVM1_bus->EVNT = !pVM1_bus->EVNT;
		}
	}
}


///