//
//  MPI_LTC.h -   50    EVNT.
//
#ifndef MPI_LTC_class_Defs
#define MPI_LTC_class_Defs

#include "MPI_model.h"


/////////////////

class MPI_LTC : public MPI_Interface {
public:
	virtual ~MPI_LTC(){}
	MPI_LTC():
	nFlips( 0 ),
	qw1ms( 0 )
	{
		LARGE_INTEGER Frq;
		bool bOK = QueryPerformanceFrequency( &Frq );
		if( bOK )
		{
			qw1ms = Frq.QuadPart/1000;
		}
	}

protected:

	VM1_bus_type      *pVM1_bus;
	MPI_AdapterHooks  *pHooks;

	virtual void   Clock();
	virtual void   Link_MPI( MPI_bus_type *pMPI, MPI_AdapterHooks *pHOOKS )
	{
		pVM1_bus = (VM1_bus_type*) pMPI;
		pHooks   = pHOOKS;
	}
	
	dword uStartTC;
	int   nFlips;

	qword qw1ms;  //     QueryPerformanceCounter  .
};

#endif
