//
//  MPI_VE_Timer.h
//
#ifndef MPI_VE_Timer_class_Defs
#define MPI_VE_Timer_class_Defs

#include "MPI_model.h"


/////////////////

class MPI_VE_Timer : public MPI_DeviceClass {
public:
	virtual ~MPI_VE_Timer(){}
	MPI_VE_Timer();

protected:
	virtual void IO_fun( IO_ModeType IO_Mode, IO_SizeType IO_Size, int nIO_Addr, word & wData );

	virtual void  Power_ON();
	virtual void  Init();

	word  w177706;
	word  w177710;
	word  w177712;

	word  wVE_Timer_Counter;
	dword dwPrevInitialVE_CounterVal;
	dword dwNextInitialVE_CounterVal;

	qword qwPrevVE_TimerStart_CPU_Clocks;
	qword qwNextVE_TimerStart_CPU_Clocks;

	bool  bVE_Go;
	bool  bVE_NoReload;
	bool  bVE_Monitor;
	bool  bVE_NoRestart;
	int   nVE_CPU_Clock_Divider;
	dword nVE_MonitoredExpiryCount;
	bool  bVE_Expiry;
};

#endif
