//
//  MPI_VM1_V.h -   18011   Verilog.
//
#ifndef MPI_VM1_V_class_Defs
#define MPI_VM1_V_class_Defs

#include "MPI_model.h"

#include "vm1cpu\vm1.h"


/////////////////

class MPI_VM1_V : public MPI_Interface {
public:
	virtual ~MPI_VM1_V(){}
	MPI_VM1_V();

protected:

	VM1_bus_type      *pVM1_bus;
	MPI_AdapterHooks  *pHooks;

	virtual void   Clock();
	virtual void   Link_MPI( MPI_bus_type *pMPI, MPI_AdapterHooks *pHOOKS )
	{
		pVM1_bus = (VM1_bus_type*) pMPI;
		pHooks   = pHOOKS;
	}

	DWORD m_nDeviceID;	

	MPI            *pMPI;
	C1801VM1        core;	
	int             nClk;

	void getPins();
	void setPins();
	
	bool  bCPU_RPLY_Prev;
	int   nCPU_AD_Prev;
	bool  bDout_AD;

	const int   nC_MicrocodeStepping;

};

#endif
